import { world, system } from "@minecraft/server";
import { getScore } from "miscellaneous/getScore";

let players = [];
let currentTick = 0;

world.events.playerJoin.subscribe((eventData) => {
  const { player } = eventData;
  players.push({
    tick: currentTick,
    player,
  });
});

system.run(function runnable() {
  system.run(runnable);

  currentTick++;

  players.forEach((value) => {
    const { player, tick } = value;

    if (currentTick % 20 != 0) {
      return;
    }

    let tickDiff = currentTick - tick;

    player.runCommand(`scoreboard players add @s secondOne 1`);
    player.onScreenDisplay.setTitle(
      `§f${getScore(player, "hourTwo")}${getScore(
        player,
        "hourOne"
      )}§f:§f${getScore(player, "minuteTwo")}${getScore(
        player,
        "minuteOne"
      )}§f:§f${getScore(player, "secondTwo")}${getScore(player, "secondOne")}`
    );
  });
});

world.events.entityHurt.subscribe(
  (data) => {
    const { hurtEntity: player } = data;
    if (data.hurtEntity.getComponent("health").current <= 0) {
      player.runCommand(`gamemode spectator @s`);
      player.runCommand(
        `tellraw @a {"rawtext":[{"selector":"@s"},{"text":" survived for "},{"score":{"name":"@s","objective":"hourTwo"}},{"score":{"name":"@s","objective":"hourOne"}},{"text":"§f:§f"},{"score":{"name":"@s","objective":"minuteTwo"}},{"score":{"name":"@s","objective":"minuteOne"}},{"text":"§f:§f"},{"score":{"name":"@s","objective":"secondTwo"}},{"score":{"name":"@s","objective":"secondOne"}}]}`
      );
    }
  },
  { type: "minecraft:player" }
);
